/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2014-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014-2015 by FUJI SOFT INCORPORATED, JAPAN  
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: ModelCarControl.h 49 2015-04-24 05:15:03Z honda $
 */

/*
 *		ǥ롼ץإåե
 */

#ifndef TOPPERS_MODEL_CAR_CONTROL_H
#define TOPPERS_MODEL_CAR_CONTROL_H

/*
 *  ̥إåե
 */
#include "driver_if.h"
#include "rc.h"

/*
 *  ѥȥϢ : ˥塼ȥΥƥ󥰳٤ν
 */
#define STEER_NEUTRAL_INIT	0


/*
 * ®ƥ󥰺/Ǿ
 */
#define DRIVE_SPEED_MAX		64
#define DRIVE_SPEED_MIN		-63
#define STEER_ANGLE_MAX		64
#define STEER_ANGLE_MIN		-63

/*
 *  ƥ󥰥˥塼ȥĴͤκ/Ǿ
 */
#define STEER_NEUTRAL_MIN	-32
#define STEER_NEUTRAL_MAX	32

/*
 *  Ĵ
 */
#define SPEED_GAIN_INIT		6
#define SPEED_GAIN_MID		10
#define SPEED_GAIN_MIN		3
#define SPEED_GAIN_MAX		17

/*
 *  ܥǥϤεư
 */
#define BODY_CYCLE_MS		100U

/*
 *  BodyControlʥ֥εư
 */
#define BODYCONTROL_RUNNABLE_CYCLE_MS		20U

/*
 *   : ưΥܥǥϤ³ƥ
 *           ǲǼ  
 */
#define INIT_BODY_BLINK_COUNT		3 
#define INIT_BODY_BLINK_CYCLE_MS	500

/*
 *   : CAN
 */
#define BODYCMD_CANMSG_SEND_CYCLE_MS	100

/*
 *  󥫡Ǽ
 */
#define WINKER_INTERVAL_MS	500U

/*
 *  ֥ѥ顼ॳХåμ
 */
#define BUZZER_CYCLE_NS		125U

/*
 *  ֥μ
 */
#define BUZZER_INTERVAL_MS	500U

/*
 *  ֥
 */
#define BUZZER_OFF			0U
#define BUZZER_ON			1U
#define BUZZER_INTERVAL_ON	2U

/*
 *  󥫡
 */
#define WINKER_OFF		0U
#define WINKER_L_ON		1U
#define WINKER_R_ON		2U
#define WINKER_LR_ON	3U
#define WINKER_L_BLINK	4U
#define WINKER_R_BLINK	5U
#define WINKER_LR_BLINK	6U

/*
 *  ϤؤΥƥ󥰥˥塼ȥϢλؼ
 */
#define CONTCMD_STEERN_I	1U
#define CONTCMD_STEERN_R	2U
#define CONTCMD_STEERN_L	3U

/*
 *  ϤؤΥ⡼Ϣλؼ
 */
#define CONTCMD_GAIN_I	1U
#define CONTCMD_GAIN_U	2U
#define CONTCMD_GAIN_D	3U

/*
 *  SW-C ν
 */
extern void CddLedBlinkerInit(void);
extern void CddBodyControlInit(void);
extern void CddControllerInit(void);
extern void CddRcCarInit(void);

/*
 * ̵(Ƥʤ)
 */
#define NOT_RECEIVE_COMMAND		0xFFFFFFFFU

#endif /* TOPPERS_MODEL_CAR_CONTROL_H */
